Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs	(revision 4368)
@@ -0,0 +1,136 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts.ResponseObjects;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Experiment.Properties;
+using System.ServiceModel;
+using HeuristicLab.Hive.Contracts;
+
+namespace HeuristicLab.Hive.Experiment {
+  [Item("Hive Client", "Connects to Hive and lists all submitted experiments by the current user.")]
+  [Creatable("Hive")]
+  public class HiveClient : Item {
+    private static object locker = new object();
+
+    private ILog log;
+    public ILog Log {
+      get { return log; }
+    }
+
+    private HiveExperimentList hiveExperiments;
+    public HiveExperimentList HiveExperiments {
+      get { return hiveExperiments; }
+      set {
+        if (hiveExperiments != value) {
+          if (hiveExperiments != null) {
+            DeRegisterHiveExperimentsEvents();
+          }
+          hiveExperiments = value;
+          RegisterHiveExperimentsEvent();
+          OnHiveExperimentsChanged();
+        }
+      }
+    }
+
+    private void RegisterHiveExperimentsEvent() {
+      hiveExperiments.ItemsAdded += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsAdded);
+      hiveExperiments.ItemsRemoved += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
+      hiveExperiments.ItemsMoved += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsMoved);
+    }
+
+    private void DeRegisterHiveExperimentsEvents() {
+      hiveExperiments.ItemsAdded -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsAdded);
+      hiveExperiments.ItemsRemoved -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
+      hiveExperiments.ItemsMoved -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsMoved);
+
+    }
+
+    public HiveClient() {
+      this.log = new Log();
+      this.HiveExperiments = new HiveExperimentList();
+    }
+
+
+    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
+      HiveClient clone = (HiveClient)base.Clone(cloner);
+      clone.log = (ILog)cloner.Clone(this.log);
+      clone.hiveExperiments = (HiveExperimentList)cloner.Clone(this.hiveExperiments);
+      return clone;
+    }
+
+    public void UpdateExperimentList() {
+      //IClientFacade client = CreateClientFacade();
+      using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
+        ResponseObject<JobResultList> response = service.Obj.GetChildJobResults(null, false, false);
+        RefreshExperimentList(response.Obj);
+      }
+      //ServiceLocator.DisposeClientFacade(client);
+    }
+
+    private void RefreshExperimentList(JobResultList jobResultList) {
+      foreach (JobResult jobResult in jobResultList) {
+        HiveExperiment hiveExperiment = GetHiveExperiment(jobResult);
+        if (hiveExperiment == null) {
+          // create new
+          hiveExperiment = new HiveExperiment() { RootJobItem = new JobItem(jobResult) };
+          this.hiveExperiments.Add(hiveExperiment);
+        } else {
+          // update
+          //hiveExperiment.RootJob.UpdateJob(jobResult);
+        }
+      }
+    }
+
+    private HiveExperiment GetHiveExperiment(JobResult jobResult) {
+      //var matches = this.hiveExperiments.Where(exp => exp.RootJob != null && exp.RootJob.JobDto.Id == jobResult.JobId);
+      //if (matches.Count() == 0) {
+      //  return null;
+      //} else {
+      //  return matches.First();
+      //}
+      return null;
+    }
+
+    //private IClientFacade CreateClientFacade() {
+    //  IClientFacade clientFacade = null;
+    //  try {
+    //    clientFacade = ServiceLocator.CreateClientFacade(Settings.Default.HiveServerIp);
+    //  }
+    //  catch (EndpointNotFoundException exception) {
+    //    LogMessage("Could not connect to Server: " + exception.Message);
+    //  }
+    //  return clientFacade;
+    //}
+
+    private void LogMessage(string message) {
+      // HeuristicLab.Log is not Thread-Safe, so lock on every call
+      lock (locker) {
+        log.LogMessage(message);
+      }
+    }
+
+    public event EventHandler HiveExperimentsChanged;
+    private void OnHiveExperimentsChanged() {
+      var handler = HiveExperimentsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    void hiveExperiments_ItemsAdded(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
+      
+    }
+
+    void hiveExperiments_ItemsRemoved(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
+      
+    }
+
+    void hiveExperiments_ItemsMoved(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
+      
+    }
+
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4368)
@@ -45,4 +45,5 @@
 using HeuristicLab.Hive.Experiment.Properties;
 using System.ComponentModel;
+using HeuristicLab.Hive.Experiment.Jobs;
 
 namespace HeuristicLab.Hive.Experiment {
@@ -51,5 +52,4 @@
   /// </summary>
   [Item(itemName, itemDescription)]
-  [Creatable("Testing & Analysis")]
   [StorableClass]
   public class HiveExperiment : NamedItem, IExecutable {
@@ -63,5 +63,4 @@
     private System.Timers.Timer timer;
     private bool pausePending, stopPending;
-    private bool sendingJobsFinished = false;
 
     // ensure that only 2 threads can fetch jobresults simultaniously
@@ -98,26 +97,5 @@
     [Storable]
     private DateTime lastUpdateTime;
-
-    /// <summary>
-    /// Mapping from JobId to an optimizer.
-    /// Stores all pending optimizers. If an optimizer is finished it is removed from this collection
-    /// </summary>
-    [Storable]
-    private IDictionary<Guid, IOptimizer> pendingOptimizersByJobId = new Dictionary<Guid, IOptimizer>();
-
-    /// <summary>
-    /// Stores a mapping from the child-optimizer to the parent optimizer.
-    /// Needed to replace a finished optimizer in the optimizer-tree.
-    /// Only pending optmizers are stored.
-    /// </summary>
-    [Storable]
-    private IDictionary<IOptimizer, IOptimizer> parentOptimizersByPendingOptimizer = new Dictionary<IOptimizer, IOptimizer>();
-
-    [Storable]
-    private JobItemList jobItems;
-    public JobItemList JobItems {
-      get { return jobItems; }
-    }
-
+    
     [Storable]
     private string resourceIds;
@@ -173,4 +151,40 @@
       }
     }
+
+    [Storable]
+    private IJob rootJob;
+    public IJob RootJob {
+      get { return rootJob; }
+      set {
+        if (rootJob != value) {
+          rootJob = value;
+          OnRootJobChanged();
+        }
+      }
+    }
+
+    private JobItem rootJobItem;
+    public JobItem RootJobItem {
+      get { return rootJobItem; }
+      set {
+        if (rootJobItem != null) {
+          DeregisterRootJobItemEvents();
+        }
+        if (rootJobItem != value) {
+          rootJobItem = value;
+          RegisterRootJobItemEvents();
+          OnRootJobItemChanged();
+        }
+      }
+    }
+
+    private void RegisterRootJobItemEvents() {
+      rootJobItem.FinalResultAvailable += new EventHandler(rootJobItem_FinalResultAvailable);
+    }
+
+    private void DeregisterRootJobItemEvents() {
+      rootJobItem.FinalResultAvailable -= new EventHandler(rootJobItem_FinalResultAvailable);
+    }
+
     #endregion
 
@@ -185,7 +199,5 @@
       this.log = new Log();
       pausePending = stopPending = false;
-      jobItems = new JobItemList();
       isPollingResults = false;
-      RegisterJobItemListEvents();
       InitTimer();
     }
@@ -198,19 +210,10 @@
       clone.executionState = this.executionState;
       clone.executionTime = this.executionTime;
-      clone.pendingOptimizersByJobId = new Dictionary<Guid, IOptimizer>();
-
-      lock (pendingOptimizerMappingsLocker) {
-        foreach (var pair in this.pendingOptimizersByJobId)
-          clone.pendingOptimizersByJobId[pair.Key] = (IOptimizer)cloner.Clone(pair.Value);
-
-        foreach (var pair in this.parentOptimizersByPendingOptimizer)
-          clone.parentOptimizersByPendingOptimizer[(IOptimizer)cloner.Clone(pair.Key)] = (IOptimizer)cloner.Clone(pair.Value);
-      }
       clone.log = (ILog)cloner.Clone(log);
       clone.stopPending = this.stopPending;
       clone.pausePending = this.pausePending;
-      clone.jobItems.AddRange((JobItemList)cloner.Clone(jobItems));
       clone.lastUpdateTime = this.lastUpdateTime;
       clone.isPollingResults = this.isPollingResults;
+      clone.rootJob = (IJob)cloner.Clone(this.rootJob);
       return clone;
     }
@@ -221,6 +224,14 @@
       this.IsPollingResults = false;
       this.stopResultsPollingPending = false;
-      RegisterJobItemListEvents();
+      RegisterEvents();
       LogMessage("I was deserialized.");
+    }
+
+    private void RegisterEvents() {
+      RootJobChanged += new EventHandler(HiveExperiment_RootJobChanged);
+    }
+
+    private void DeRegisterEvents() {
+      RootJobChanged -= new EventHandler(HiveExperiment_RootJobChanged);
     }
 
@@ -247,11 +258,4 @@
       if (experiment != null) {
         StopResultPolling();
-        lock (pendingOptimizerMappingsLocker) {
-          pendingOptimizersByJobId.Clear();
-          parentOptimizersByPendingOptimizer.Clear();
-        }
-        lock (jobItems) {
-          jobItems.Clear();
-        }
         experiment.Prepare();
         this.ExecutionState = Core.ExecutionState.Prepared;
@@ -261,49 +265,33 @@
 
     public void Start() {
-      sendingJobsFinished = false;
       OnStarted();
       ExecutionTime = new TimeSpan();
       lastUpdateTime = DateTime.Now;
       this.ExecutionState = Core.ExecutionState.Started;
-      StartResultPolling();
 
       Thread t = new Thread(() => {
-        IClientFacade clientFacade = CreateStreamedClientFacade();
-
-        try {
-          pendingOptimizersByJobId = new Dictionary<Guid, IOptimizer>();
-
-          LogMessage("Extracting jobs from Experiment");
-          parentOptimizersByPendingOptimizer = GetOptimizers(true);
-          LogMessage("Extraction of jobs from Experiment finished");
-
-          IEnumerable<string> groups = ResourceGroups;
-          lock (pendingOptimizerMappingsLocker) {
-            foreach (IOptimizer optimizer in parentOptimizersByPendingOptimizer.Keys) {
-              SerializedJob serializedJob = CreateSerializedJob(optimizer);
-              ResponseObject<JobDto> response = clientFacade.AddJobWithGroupStrings(serializedJob, groups);
-              pendingOptimizersByJobId.Add(response.Obj.Id, optimizer);
-
-              JobItem jobItem = new JobItem() {
-                JobDto = response.Obj,
-                LatestSnapshot = null,
-                Optimizer = optimizer
-              };
-              lock (jobItems) {
-                jobItems.Add(jobItem);
-              }
-              LogMessage(jobItem.JobDto.Id, "Job sent to Hive");
+        using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+          try {
+            RootJobItem = ToJobItem(RootJob);
+
+            IEnumerable<string> groups = ResourceGroups;
+            SerializedJob serializedJob = RootJobItem.ToSerializedJob();
+            ResponseObject<JobDto> response = service.Obj.AddJobWithGroupStrings(serializedJob, groups);
+
+            if (response.StatusMessage != ResponseStatus.Ok) {
+              throw new Exception(response.StatusMessage.ToString());
+            } else {
+              RootJobItem.JobDto = response.Obj;
+              LogMessage(RootJobItem.JobDto.Id, "Job sent to Hive");
+
+              StartResultPolling();
             }
           }
-        }
-        catch (Exception e) {
-          LogMessage("Error: Starting HiveExperiment failed: " + e.Message);
-          this.ExecutionState = Core.ExecutionState.Stopped;
-          OnStopped();
-        }
-        finally {
-          ServiceLocator.DisposeClientFacade(clientFacade);
-        }
-        sendingJobsFinished = true;
+          catch (Exception e) {
+            LogMessage("Error: Starting HiveExperiment failed: " + e.Message);
+            this.ExecutionState = Core.ExecutionState.Stopped;
+            OnStopped();
+          }
+        }
       });
       t.Start();
@@ -311,127 +299,122 @@
 
     public void Stop() {
+      if (IsPollingResults)
+        StopResultPolling();
       this.ExecutionState = Core.ExecutionState.Stopped;
-      foreach (JobItem jobItem in jobItems) {
-        AbortJob(jobItem.JobDto.Id);
-      }
       OnStopped();
     }
     #endregion
-
-    #region Optimizier Management
-    /// <summary>
-    /// Returns all optimizers in the current Experiment
-    /// </summary>
-    /// <param name="flatout">if false only top level optimizers are returned, if true the optimizer-tree is flatted</param>
-    /// <returns></returns>
-    private IDictionary<IOptimizer, IOptimizer> GetOptimizers(bool flatout) {
-      if (!flatout) {
-        var optimizers = new Dictionary<IOptimizer, IOptimizer>();
-        foreach (IOptimizer opt in experiment.Optimizers) {
-          optimizers.Add(experiment, opt);
-        }
-        return optimizers;
+    
+    #region Job Management
+    public void RefreshJobTree() {
+      this.RootJob = CreateJobTree(this.Experiment);
+    }
+    
+    private IJob CreateJobTree(IOptimizer optimizer) {
+      IJob job = null;
+      if (optimizer is HeuristicLab.Optimization.Experiment) {
+        HeuristicLab.Optimization.Experiment exp = (HeuristicLab.Optimization.Experiment)optimizer;
+        ExperimentJob expJob = new ExperimentJob(exp);
+        foreach (IOptimizer opt in exp.Optimizers) {
+          expJob.AddChildJob(CreateJobTree(opt));
+        }
+        job = expJob;
+      } else if (optimizer is BatchRun) {
+        job = new BatchRunJob(optimizer);
       } else {
-        return FlatOptimizerTree(null, experiment, "");
-      }
-    }
-
-    /// <summary>
-    /// Recursively iterates all IOptimizers in the optimizer-tree and returns them.
-    /// 
-    /// [chn] this could be implemented more cleanly if Experiment and BatchRun would implement an interface like:
-    /// interface IParallelizable {
-    ///   IEnumerable&lt;IOptimizer&gt; GetOptimizers();
-    /// }
-    /// </summary>
-    /// <returns>a dictionary mapping from the parent optimizer to the child optimizer</returns>
-    private IDictionary<IOptimizer, IOptimizer> FlatOptimizerTree(IOptimizer parent, IOptimizer optimizer, string prepend) {
-      IDictionary<IOptimizer, IOptimizer> optimizers = new Dictionary<IOptimizer, IOptimizer>();
-      if (optimizer is HeuristicLab.Optimization.Experiment) {
-        HeuristicLab.Optimization.Experiment experiment = optimizer as HeuristicLab.Optimization.Experiment;
-        if (this.experiment != experiment) {
-          prepend += experiment.Name + "/"; // don't prepend for top-level optimizers
-        }
-        foreach (IOptimizer opt in experiment.Optimizers) {
-          AddRange(optimizers, FlatOptimizerTree(experiment, opt, prepend));
-        }
-      } else if (optimizer is BatchRun) {
-        BatchRun batchRun = optimizer as BatchRun;
-        prepend += batchRun.Name + "/";
-        for (int i = 0; i < batchRun.Repetitions; i++) {
-          IOptimizer opt = (IOptimizer)batchRun.Algorithm.Clone();
-          opt.Name += " [" + i + "]";
-          IDictionary<IOptimizer, IOptimizer> batchOptimizers = FlatOptimizerTree(batchRun, opt, prepend);
-          AddRange(optimizers, batchOptimizers);
-        }
-      } else if (optimizer is EngineAlgorithm) {
-        optimizer.Name = prepend + optimizer.Name;
-        optimizers.Add(optimizer, parent);
-        LogMessage("Optimizer extracted: " + optimizer.Name);
-      } else {
-        Logger.Warn("Optimizer of type " + optimizers.GetType().ToString() + " unknown");
-        optimizer.Name = prepend + optimizer.Name;
-        optimizers.Add(optimizer, parent);
-        LogMessage("Optimizer extracted: " + optimizer.Name);
-      }
-      return optimizers;
-    }
-
-    private void ReplaceOptimizer(IOptimizer parentOptimizer, IOptimizer originalOptimizer, IOptimizer newOptimizer) {
-      lock (locker) {
-        if (parentOptimizer is HeuristicLab.Optimization.Experiment) {
-          HeuristicLab.Optimization.Experiment exp = (HeuristicLab.Optimization.Experiment)parentOptimizer;
-          int originalOptimizerIndex = exp.Optimizers.IndexOf(originalOptimizer);
-          exp.Optimizers[originalOptimizerIndex] = newOptimizer;
-        } else if (parentOptimizer is BatchRun) {
-          BatchRun batchRun = (BatchRun)parentOptimizer;
-          if (newOptimizer is IAlgorithm) {
-            batchRun.Runs.Add(new Run(newOptimizer.Name, (IAlgorithm)newOptimizer));
-          } else {
-            throw new NotSupportedException("Only IAlgorithm types supported");
-          }
-        } else {
-          throw new NotSupportedException("Invalid parentOptimizer");
-        }
-      }
-    }
-
-    private bool NoMorePendingOptimizers() {
-      lock (pendingOptimizerMappingsLocker) {
-        return pendingOptimizersByJobId.Count == 0;
-      }
-    }
-
-    /// <summary>
-    /// Removes optimizers from
-    ///  - parentOptimizersByPendingOptimizer
-    ///  - pendingOptimizersByJobId
-    /// </summary>
-    /// <param name="jobId"></param>
-    private void DisposeOptimizerMappings(Guid jobId) {
-      LogMessage(jobId, "Disposing Optimizer Mappings");
-      lock (pendingOptimizerMappingsLocker) {
-        parentOptimizersByPendingOptimizer.Remove(pendingOptimizersByJobId[jobId]);
-        pendingOptimizersByJobId.Remove(jobId);
-      }
-    }
-
-    #endregion
-
-    #region Job Management
+        job = new OptimizerJob(optimizer);
+      }
+      return job;
+    }
+
+    private JobItem ToJobItem(IJob j) {
+      return new JobItem() {
+        Job = j,
+        JobDto = new JobDto() {
+          State = JobState.Offline,
+          PluginsNeeded = HivePluginInfoDto.FindPluginsNeeded(j.GetType())
+        }
+      };
+    }
+
     /// <summary>
     /// Updates all JobItems with the results
+    /// if one is finished, the serialized job is downloaded and updated
     /// </summary>
     /// <param name="jobResultList"></param>
     private void UpdateJobItems(JobResultList jobResultList) {
-      // use a Dict to avoid quadratic runtime complexity
-      IDictionary<Guid, JobResult> jobResultDict = jobResultList.ToDictionary(job => job.JobId);
-      lock (jobItems) {
-        foreach (JobItem jobItem in JobItems) {
-          if (jobResultDict.ContainsKey(jobItem.JobDto.Id)) {
-            jobItem.JobResult = jobResultDict[jobItem.JobDto.Id];
+      if (RootJobItem == null) {
+        var rootResults = jobResultList.Where(res => !res.ParentJobId.HasValue);
+        if (rootResults.Count() > 0) {
+          RootJobItem = new JobItem(rootResults.First());
+        } else {
+          LogMessage("Error: Could not find JobResult for RootJobItem");
+          return;
+        }
+      }
+
+      using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+        foreach (JobResult jobResult in jobResultList) {
+          JobItem jobItem = FindJobItem(RootJobItem, jobResult.Id);
+          if (jobItem != null) {
+            jobItem.UpdateJob(jobResult);
+            if (jobItem.JobDto.State == JobState.Finished && !jobItem.IsFinalResultAvailable) {
+              // job is finished but the final result was not yet downloaded
+              SerializedJob serializedJob = service.Obj.GetLastSerializedResult(jobResult.Id).Obj;
+              jobItem.Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob.SerializedJobData));
+              UpdateChildJobs(jobItem);
+              this.Experiment.Runs.AddRange(((OptimizerJob)jobItem.Job).Optimizer.Runs);
+              //ReplaceOptimizerInExperiment(jobItem.JobDto.Id, jobItem.Job);
+            }
+          } else {
+            // job does not yet exist locally
+            JobItem parentJobItem = FindJobItem(RootJobItem, jobResult.ParentJobId.Value);
+            if (parentJobItem != null) {
+              LogMessage(jobResult.Id, "Creating JobItem");
+              SerializedJob serializedJob = service.Obj.GetLastSerializedResult(jobResult.Id).Obj;
+              JobItem newJobItem = new JobItem();
+              newJobItem.JobDto = serializedJob.JobInfo;
+              newJobItem.Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob.SerializedJobData));
+              parentJobItem.AddChildJob(newJobItem);
+              if (newJobItem.JobDto.State == JobState.Finished && newJobItem.IsFinalResultAvailable) {
+                this.Experiment.Runs.AddRange(((OptimizerJob)newJobItem.Job).Optimizer.Runs);
+                UpdateChildJobs(newJobItem);
+                //ReplaceOptimizerInExperiment(jobItem.JobDto.Id, jobItem.Job);
+              }
+            } else {
+              LogMessage("Error: Could not update JobResult for " + jobResult.Id);
+            }
           }
         }
       }
+    }
+
+    /// <summary>
+    /// Updates the ChildJobItems of a JobItem according to the IJob.ChildJobs of JobItem.Job (pretty confusing, right)
+    /// </summary>
+    /// <param name="jobItem"></param>
+    private void UpdateChildJobs(JobItem jobItem) {
+      List<JobItem> newJobItems = new List<JobItem>();
+      foreach (IJob job in jobItem.Job.ChildJobs) {
+        if (!jobItem.ReplaceChildJob(job)) {
+          newJobItems.Add(ToJobItem(job));
+        }
+      }
+      foreach (JobItem item in newJobItems) {
+        jobItem.AddChildJob(item);
+      }
+    }
+
+    private JobItem FindJobItem(JobItem parentJobItem, Guid jobId) {
+      if (parentJobItem.JobDto.Id == jobId) {
+        return parentJobItem;
+      } else {
+        foreach (JobItem child in parentJobItem.ChildJobItems) {
+          JobItem result = FindJobItem(child, jobId);
+          if (result != null)
+            return result;
+        }
+      }
+      return null;
     }
 
@@ -441,19 +424,11 @@
       Thread t = new Thread(() => {
         try {
-          if (jobItem.State == JobState.Finished) {
+          if (jobItem.JobDto.State == JobState.Finished) {
             FetchAndUpdateJob(jobItem.JobDto.Id);
-            DisposeOptimizerMappings(jobItem.JobDto.Id);
-          } else if (jobItem.State == JobState.Failed) {
-            DisposeOptimizerMappings(jobItem.JobDto.Id);
+          } else if (jobItem.JobDto.State == JobState.Failed) {
+            
           }
-
-          if (NoMorePendingOptimizers()) {
-            StopResultPolling();
-            this.ExecutionState = Core.ExecutionState.Stopped;
-            OnStopped();
-          }
         }
         catch (Exception ex) {
-          Logger.Error("JobItem_JobStateChanged failed badly: " + ex.Message);
           LogMessage("JobItem_JobStateChanged failed badly: " + ex.Message);
         }
@@ -469,15 +444,12 @@
       LogMessage(jobId, "FetchAndUpdateJob started");
       if (fetchJobSemaphore.WaitOne(new TimeSpan(0, 2, 0))) {
-        IClientFacade clientFacade = null;
+
         try {
-          clientFacade = CreateStreamedClientFacade();
-          IOptimizer originalOptimizer;
-          originalOptimizer = pendingOptimizersByJobId[jobId];
-
-          ResponseObject<SerializedJob> jobResponse = clientFacade.GetLastSerializedResult(jobId, false, false);
-          IJob restoredObject = XmlParser.Deserialize<IJob>(new MemoryStream(jobResponse.Obj.SerializedJobData));
-          IOptimizer restoredOptimizer = ((OptimizerJob)restoredObject).Optimizer;
-          ReplaceOptimizer(parentOptimizersByPendingOptimizer[originalOptimizer], originalOptimizer, restoredOptimizer);
-          LogMessage(jobId, "FetchAndUpdateJob ended");
+          using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+            ResponseObject<SerializedJob> jobResponse = service.Obj.GetLastSerializedResult(jobId);
+            IJob restoredObject = XmlParser.Deserialize<IJob>(new MemoryStream(jobResponse.Obj.SerializedJobData));
+            IOptimizer restoredOptimizer = ((OptimizerJob)restoredObject).Optimizer;
+            LogMessage(jobId, "FetchAndUpdateJob ended");
+          }
         }
         catch (Exception e) {
@@ -486,5 +458,4 @@
         }
         finally {
-          ServiceLocator.DisposeClientFacade(clientFacade);
           fetchJobSemaphore.Release();
         }
@@ -499,51 +470,9 @@
     }
 
-    private void UpdateJobItem(JobDto jobDto) {
-      JobItem jobItem = jobItems.Single(x => x.JobDto.Id == jobDto.Id);
-      jobItem.JobDto = jobDto;
-    }
-
     public void AbortJob(Guid jobId) {
-      IClientFacade clientFacade = CreateClientFacade();
-      Response response = clientFacade.AbortJob(jobId);
-      LogMessage(jobId, "Aborting Job: " + response.StatusMessage);
-    }
-
-    private SerializedJob CreateSerializedJob(IOptimizer optimizer) {
-      IJob job = new OptimizerJob() {
-        Optimizer = optimizer
-      };
-
-      // serialize job
-      MemoryStream memStream = new MemoryStream();
-      XmlGenerator.Serialize(job, memStream);
-      byte[] jobByteArray = memStream.ToArray();
-      memStream.Dispose();
-
-      // find out which which plugins are needed for the given object
-      List<HivePluginInfoDto> pluginsNeeded = (
-        from p in GetDeclaringPlugins(job.GetType())
-        select new HivePluginInfoDto() {
-          Name = p.Name,
-          Version = p.Version
-        }).ToList();
-
-      JobDto jobDto = new JobDto() {
-        CoresNeeded = 1, // [chn] how to determine real cores needed?
-        PluginsNeeded = pluginsNeeded,
-        State = JobState.Offline,
-        MemoryNeeded = 0
-      };
-
-      SerializedJob serializedJob = new SerializedJob() {
-        JobInfo = jobDto,
-        SerializedJobData = jobByteArray
-      };
-
-      return serializedJob;
-    }
-
-    private JobItem GetJobItemById(Guid jobId) {
-      return jobItems.Single(x => x.JobDto.Id == jobId);
+      using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
+        Response response = service.Obj.AbortJob(jobId);
+        LogMessage(jobId, "Aborting Job: " + response.StatusMessage);
+      }
     }
     #endregion
@@ -553,5 +482,5 @@
       this.stopResultsPollingPending = false;
       this.IsPollingResults = true;
-      resultPollingThread = CreateResultPollingThread();
+      resultPollingThread = new Thread(RunResultPollingThread);
       if (resultPollingThread.ThreadState != System.Threading.ThreadState.Running)
         resultPollingThread.Start();
@@ -560,23 +489,21 @@
     public void StopResultPolling() {
       this.stopResultsPollingPending = true;
-      if (resultPollingThread != null && resultPollingThread.ThreadState == System.Threading.ThreadState.WaitSleepJoin) {
-        resultPollingThread.Interrupt();
+      if (resultPollingThread != null) {
+        if (resultPollingThread.ThreadState == System.Threading.ThreadState.WaitSleepJoin) {
+          resultPollingThread.Interrupt();
+        }
+        resultPollingThread.Join();
       }
       this.stopResultsPollingPending = false;
     }
 
-    private Thread CreateResultPollingThread() {
-      return new Thread(() => {
-        try {
-          do {
-            IClientFacade clientFacade = CreateStreamedClientFacade();
-            IEnumerable<Guid> jobIdsToQuery = from job in JobItems
-                                              where job.State != JobState.Finished &&
-                                              job.State != JobState.Failed
-                                              select job.JobDto.Id;
-            if (jobIdsToQuery.Count() > 0) {
-              LogMessage("Polling results for " + jobIdsToQuery.Count() + " jobs");
+    private void RunResultPollingThread() {
+      try {
+        do {
+          if (RootJobItem.JobDto.State != JobState.Finished) {
+            using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+              LogMessage("Polling results");
               try {
-                ResponseObject<JobResultList> response = clientFacade.GetJobResults(jobIdsToQuery);
+                ResponseObject<JobResultList> response = service.Obj.GetChildJobResults(RootJobItem.JobDto.Id, true, true);
                 if (response.StatusMessage == ResponseStatus.Ok) {
                   JobResultList jobItemList = response.Obj;
@@ -591,27 +518,21 @@
                 LogMessage("Polling results failed: " + e.Message);
               }
-              finally {
-                ServiceLocator.DisposeClientFacade(clientFacade);
-              }
-              Thread.Sleep(resultPollingIntervalMs);
-            } else {
-              if (sendingJobsFinished) {
-                // all the jobs have been sent to hive, but non are to query any more (all finished or failed)
-                this.stopResultsPollingPending = true;
-              }
             }
-          } while (!this.stopResultsPollingPending);
-        }
-        catch (ThreadInterruptedException exception) {
-          // thread has been interuppted
-        }
-        catch (Exception e) {
-          LogMessage("Result Polling Thread failed badly: " + e.Message);
-          Logger.Error("Result Polling Thread failed badly: " + e.Message);
-        }
-        finally {
-          this.IsPollingResults = false;
-        }
-      });
+            Thread.Sleep(resultPollingIntervalMs);
+          } else {
+            // all the jobs have been sent to hive, but non are to query any more (all finished or failed)
+            this.stopResultsPollingPending = true;
+          }
+        } while (!this.stopResultsPollingPending);
+      }
+      catch (ThreadInterruptedException) {
+        // thread has been interuppted
+      }
+      catch (Exception e) {
+        LogMessage("Result Polling Thread failed badly: " + e.Message);
+      }
+      finally {
+        this.IsPollingResults = false;
+      }
     }
 
